Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jboss.cache
Interface TreeCacheMBean

All Superinterfaces:
  org.jboss.system.Service, org.jboss.system.ServiceMBean

All Known Subinterfaces:
  TreeCacheAopMBean

All Known Implementing Classes:
  TreeCache, TreeCacheAop

public interface TreeCacheMBean
extends org.jboss.system.ServiceMBean

MBean interface.

Author:
  Bela Ban, Ben Wang

Field Summary

Fields inherited from interface org.jboss.system.ServiceMBean
`CREATE_EVENT, CREATED, DESTROY_EVENT, DESTROYED, FAILED, REGISTERED, START_EVENT, STARTED, STARTING, states, STOP_EVENT, STOPPED, STOPPING, UNREGISTERED`

Method Summary
`void` | `_put(GlobalTransaction tx, Fqn fqn, Map data, boolean create_undo_ops)` Does the real work.
`void` | `_put(GlobalTransaction tx, Fqn fqn, Map data, boolean create_undo_ops, boolean erase_contents)` Does the real work.
`Object` | `_put(GlobalTransaction tx, Fqn fqn, Object key, Object value, boolean create_undo_ops)`
`void` | `_put(GlobalTransaction tx, String fqn, Map data, boolean create_undo_ops)` Does the real work.
`Object` | `_put(GlobalTransaction tx, String fqn, Object key, Object value, boolean create_undo_ops)`
`void` | `_remove(GlobalTransaction tx, Fqn fqn, boolean create_undo_ops)`
`Object` | `_remove(GlobalTransaction tx, Fqn fqn, Object key, boolean create_undo_ops)`
`void` | `_remove(GlobalTransaction tx, String fqn, boolean create_undo_ops)`
`Object` | `_remove(GlobalTransaction tx, String fqn, Object key, boolean create_undo_ops)`
`void` | `addTreeCacheListener(TreeCacheListener listener)`
`List` | `callRemoteMethods(Vector members, Method method, Object[] args, boolean synchronous, boolean exclude_self, long timeout)`
`List` | `callRemoteMethods(Vector members, String method_name, Class[] types, Object[] args, boolean synchronous, boolean exclude_self, long timeout)`
`void` | `createService()`
`void` | `destroyService()`
`String` | `dumpTransactionTable()` Dumps the contents of the TransactionTable
`void` | `evict(Fqn fqn)` Called by eviction policy provider.
`void` | `evict(Fqn fqn, Object key)` Evicts a key/value pair from a node's attributes.
`boolean` | `exists(Fqn fqn)` Checks whether a given node exists in the tree.
`boolean` | `exists(Fqn fqn, Object key)` Checks whether a given key exists in the given node.
`boolean` | `exists(String fqn)` Checks whether a given node exists in the tree
`boolean` | `exists(String fqn, Object key)`
`void` | `fetchState(long timeout)` Fetch the group state from the current coordinator.
`Object` | `get(Fqn fqn, Object key)` Finds a node given its name and returns the value associated with a given key in its `data` map.
`Object` | `get(String fqn, Object key)` Finds a node given its name and returns the value associated with a given key in its `data` map.
`CacheLoader` | `getCacheLoader()`
`String` | `getCacheLoaderClass()`
`Properties` | `getCacheLoaderConfig()`
`boolean` | `getCacheLoaderFetchPersistentState()`
`boolean` | `getCacheLoaderFetchTransientState()`
`String` | `getCacheLoaderPreload()`
`boolean` | `getCacheLoaderShared()`
`String` | `getCacheMode()` Returns the current caching mode.
`Set` | `getChildrenNames(Fqn fqn)` Returns all children of a given node
`Set` | `getChildrenNames(String fqn)` Returns all children of a given node
`String` | `getClusterName()` Get the name of the replication group
`String` | `getClusterProperties()` Get the cluster properties (e.g.
`String` | `getEvictionPolicyClass()` Returns the name of the cache eviction policy (must be an implementation of EvictionPolicy)
`int` | `getEvictionThreadWakeupIntervalSeconds()` Obtain eviction thread (if any) wake up interval in seconds
`boolean` | `getFetchStateOnStartup()`
`long` | `getInitialStateRetrievalTimeout()` Get the max time to wait until the initial state is retrieved.
`TreeCache` | `getInstance()`
`String` | `getInterceptorChain()`
`List` | `getInterceptors()`
`String` | `getIsolationLevel()` Returns the transaction isolation level.
`String` | `getJndiName()`
`Set` | `getKeys(Fqn fqn)`
`Set` | `getKeys(String fqn)`
`Object` | `getLocalAddress()`
`long` | `getLockAcquisitionTimeout()` Default max time to wait for a lock.
`Vector` | `getMembers()`
`int` | `getNumberOfAttributes()` Returns an approximation of the total number of attributes in the tree.
`int` | `getNumberOfLocksHeld()` Gets the number of read or write locks held across the entire tree
`int` | `getNumberOfNodes()` Returns an approximation of the total number of nodes in the tree.
`Properties` | `getRemoteProxy()`
`long` | `getReplQueueInterval()`
`int` | `getReplQueueMaxElements()`
`boolean` | `getSyncCommitPhase()`
`long` | `getSyncReplTimeout()` Returns the default max timeout after which synchronous replication calls return.
`boolean` | `getSyncRollbackPhase()`
`TransactionManager` | `getTransactionManager()`
`String` | `getTransactionManagerLookupClass()`
`boolean` | `getUseReplQueue()`
`boolean` | `isCoordinator()`
`void` | `load(String fqn)` Loads the indicated Fqn, plus all parents recursively from the CacheLoader.
`String` | `print(Fqn fqn)` Prints a representation of the node defined by `fqn`.
`String` | `print(String fqn)` Prints a representation of the node defined by `fqn`.
`String` | `printDetails()`
`String` | `printLockInfo()`
`void` | `put(Fqn fqn, Map data)` Adds a new node to the tree and sets its data.
`Object` | `put(Fqn fqn, Object key, Object value)` Adds a key and value to a given node.
`void` | `put(String fqn, Map data)` Adds a new node to the tree and sets its data.
`Object` | `put(String fqn, Object key, Object value)` Adds a key and value to a given node.
`void` | `releaseAllLocks(Fqn fqn)` Force-releases all locks in this node and the entire subtree
`void` | `releaseAllLocks(String fqn)` Force-releases all locks in this node and the entire subtree
`void` | `remove(Fqn fqn)` Removes the node from the tree.
`Object` | `remove(Fqn fqn, Object key)` Removes `key` from the node's hashmap
`void` | `remove(String fqn)` Removes the node from the tree.
`Object` | `remove(String fqn, Object key)` Removes `key` from the node's hashmap
`void` | `removeData(Fqn fqn)`
`void` | `removeData(String fqn)`
`void` | `removeTreeCacheListener(TreeCacheListener listener)`
`void` | `setCacheLoader(CacheLoader cache_loader)`
`void` | `setCacheLoaderClass(String cache_loader_class)`
`void` | `setCacheLoaderConfig(Properties cache_loader_config)`
`void` | `setCacheLoaderFetchPersistentState(boolean flag)`
`void` | `setCacheLoaderFetchTransientState(boolean flag)`
`void` | `setCacheLoaderPreload(String list)`
`void` | `setCacheLoaderShared(boolean shared)`
`void` | `setCacheMode(String mode)` Sets the default caching mode)
`void` | `setClusterConfig(Element config)` Convert a list of elements to the JG property string
`void` | `setClusterName(String name)` Set the name of the replication group
`void` | `setClusterProperties(String cluster_props)` Set the cluster properties.
`void` | `setEvictionPolicyClass(String eviction_policy_class)` Sets the classname of the eviction policy
`void` | `setEvictionPolicyConfig(Element config)` Setup eviction policy configuration
`void` | `setFetchStateOnStartup(boolean flag)`
`void` | `setInitialStateRetrievalTimeout(long timeout)` Set the initial state transfer timeout (see `getInitialStateRetrievalTimeout()`)
`void` | `setIsolationLevel(String level)` Set the transaction isolation level.
`void` | `setJndiName(String jndi_name)`
`void` | `setLockAcquisitionTimeout(long timeout)` Set the max time for lock acquisition.
`void` | `setRemoteProxy(Properties info)`
`void` | `setReplQueueInterval(long interval)`
`void` | `setReplQueueMaxElements(int max_elements)`
`void` | `setSyncCommitPhase(boolean sync_commit_phase)`
`void` | `setSyncReplTimeout(long timeout)` Sets the default maximum wait time for synchronous replication to receive all results
`void` | `setSyncRollbackPhase(boolean sync_rollback_phase)`
`void` | `setTransactionManagerLookup(TransactionManagerLookup l)` Sets the TransactionManagerLookup object
`void` | `setTransactionManagerLookupClass(String cl)` Sets the class of the TransactionManagerLookup impl.
`void` | `setUseReplQueue(boolean flag)`
`void` | `startService()`
`void` | `stopService()`
`String` | `toString()`

Methods inherited from interface org.jboss.system.ServiceMBean
`getName, getState, getStateString, jbossInternalLifecycle`

Methods inherited from interface org.jboss.system.Service
`create, destroy, start, stop`

Method Detail

### getLocalAddress

    public Object getLocalAddress()

### getMembers

    public Vector getMembers()

### isCoordinator

    public boolean isCoordinator()

### getClusterName

    public String getClusterName()

  Get the name of the replication group

### setClusterName

    public void setClusterName(String name)

  Set the name of the replication group

### getClusterProperties

    public String getClusterProperties()

  Get the cluster properties (e.g. the protocol stack specification in case of JGroups)

### setClusterProperties

    public void setClusterProperties(String cluster_props)

  Set the cluster properties. If the cache is to use the new properties, it has to be redeployed

  Parameters:
    `cluster_props` - The properties for the cluster (JGroups)

### dumpTransactionTable

    public String dumpTransactionTable()

  Dumps the contents of the TransactionTable

  Returns:

### getInterceptorChain

    public String getInterceptorChain()

### getInterceptors

    public List getInterceptors()

### getCacheLoaderClass

    public String getCacheLoaderClass()

### setCacheLoaderClass

    public void setCacheLoaderClass(String cache_loader_class)

### getCacheLoaderConfig

    public Properties getCacheLoaderConfig()

### setCacheLoaderConfig

    public void setCacheLoaderConfig(Properties cache_loader_config)

### getCacheLoader

    public CacheLoader getCacheLoader()

### setCacheLoader

    public void setCacheLoader(CacheLoader cache_loader)

### getCacheLoaderShared

    public boolean getCacheLoaderShared()

### setCacheLoaderShared

    public void setCacheLoaderShared(boolean shared)

### setCacheLoaderPreload

    public void setCacheLoaderPreload(String list)

### getCacheLoaderPreload

    public String getCacheLoaderPreload()

### setCacheLoaderFetchPersistentState

    public void setCacheLoaderFetchPersistentState(boolean flag)

### getCacheLoaderFetchPersistentState

    public boolean getCacheLoaderFetchPersistentState()

### setCacheLoaderFetchTransientState

    public void setCacheLoaderFetchTransientState(boolean flag)

### getCacheLoaderFetchTransientState

    public boolean getCacheLoaderFetchTransientState()

### getSyncCommitPhase

    public boolean getSyncCommitPhase()

### setSyncCommitPhase

    public void setSyncCommitPhase(boolean sync_commit_phase)

### getSyncRollbackPhase

    public boolean getSyncRollbackPhase()

### setSyncRollbackPhase

    public void setSyncRollbackPhase(boolean sync_rollback_phase)

### setEvictionPolicyConfig

    public void setEvictionPolicyConfig(Element config)

  Setup eviction policy configuration

### setClusterConfig

    public void setClusterConfig(Element config)

  Convert a list of elements to the JG property string

### getInitialStateRetrievalTimeout

    public long getInitialStateRetrievalTimeout()

  Get the max time to wait until the initial state is retrieved. This is used in a replicating cache: when a new cache joins the cluster, it needs to acquire the (replicated) state of the other members to initialize itself. If no state has been received within `timeout` milliseconds, the map will be empty.

  Returns:
    long Number of milliseconds to wait for the state. 0 means to wait forever.

### setInitialStateRetrievalTimeout

    public void setInitialStateRetrievalTimeout(long timeout)

  Set the initial state transfer timeout (see `getInitialStateRetrievalTimeout()`)

### getCacheMode

    public String getCacheMode()

  Returns the current caching mode. Valid values are
  - LOCAL
  - REPL_ASYNC
  - REPL_SYNC

  Returns:
    String The caching mode

### setCacheMode

    public void setCacheMode(String mode)
                      throws Exception

  Sets the default caching mode)

  Throws:
    `Exception`

### getSyncReplTimeout

    public long getSyncReplTimeout()

  Returns the default max timeout after which synchronous replication calls return.

  Returns:
    long Number of milliseconds after which a sync repl call must return. 0 means to wait forever

### setSyncReplTimeout

    public void setSyncReplTimeout(long timeout)

  Sets the default maximum wait time for synchronous replication to receive all results

### getUseReplQueue

    public boolean getUseReplQueue()

### setUseReplQueue

    public void setUseReplQueue(boolean flag)

### getReplQueueInterval

    public long getReplQueueInterval()

### setReplQueueInterval

    public void setReplQueueInterval(long interval)

### getReplQueueMaxElements

    public int getReplQueueMaxElements()

### setReplQueueMaxElements

    public void setReplQueueMaxElements(int max_elements)

### getIsolationLevel

    public String getIsolationLevel()

  Returns the transaction isolation level.

### setIsolationLevel

    public void setIsolationLevel(String level)

  Set the transaction isolation level. This determines the locking strategy to be used

### getFetchStateOnStartup

    public boolean getFetchStateOnStartup()

### setFetchStateOnStartup

    public void setFetchStateOnStartup(boolean flag)

### getLockAcquisitionTimeout

    public long getLockAcquisitionTimeout()

  Default max time to wait for a lock. If the lock cannot be acquired within this time, a LockingException will be thrown.

  Returns:
    long Max number of milliseconds to wait for a lock to be acquired

### setLockAcquisitionTimeout

    public void setLockAcquisitionTimeout(long timeout)

  Set the max time for lock acquisition. A value of 0 means to wait forever (not recomended). Note that lock acquisition timeouts may be removed in the future when we have deadlock detection.

  Parameters:
    `timeout` -

### getEvictionPolicyClass

    public String getEvictionPolicyClass()

  Returns the name of the cache eviction policy (must be an implementation of EvictionPolicy)

  Returns:
    Fully qualified name of a class implementing the EvictionPolicy interface

### setEvictionPolicyClass

    public void setEvictionPolicyClass(String eviction_policy_class)

  Sets the classname of the eviction policy

### getEvictionThreadWakeupIntervalSeconds

    public int getEvictionThreadWakeupIntervalSeconds()

  Obtain eviction thread (if any) wake up interval in seconds

### setTransactionManagerLookup

    public void setTransactionManagerLookup(TransactionManagerLookup l)

  Sets the TransactionManagerLookup object

  Parameters:
    `l` -

### getTransactionManagerLookupClass

    public String getTransactionManagerLookupClass()

### setTransactionManagerLookupClass

    public void setTransactionManagerLookupClass(String cl)
                                          throws Exception

  Sets the class of the TransactionManagerLookup impl. This will attempt to create an instance, and will throw an exception if this fails.

  Parameters:
    `cl` -
  Throws:
    `Exception`

### getTransactionManager

    public TransactionManager getTransactionManager()

### getInstance

    public TreeCache getInstance()

### getJndiName

    public String getJndiName()

### setJndiName

    public void setJndiName(String jndi_name)
                     throws Exception

  Throws:
    `Exception`

### getRemoteProxy

    public Properties getRemoteProxy()

### setRemoteProxy

    public void setRemoteProxy(Properties info)
                        throws Exception

  Throws:
    `Exception`

### fetchState

    public void fetchState(long timeout)
                    throws org.jgroups.ChannelClosedException,
                           org.jgroups.ChannelNotConnectedException

  Fetch the group state from the current coordinator. If successful, this will trigger setState().

  Throws:
    `org.jgroups.ChannelClosedException`
    `org.jgroups.ChannelNotConnectedException`

### addTreeCacheListener

    public void addTreeCacheListener(TreeCacheListener listener)

### removeTreeCacheListener

    public void removeTreeCacheListener(TreeCacheListener listener)

### createService

    public void createService()
                       throws Exception

  Throws:
    `Exception`

### destroyService

    public void destroyService()

### startService

    public void startService()
                      throws Exception

  Throws:
    `Exception`

### load

    public void load(String fqn)
              throws Exception

  Loads the indicated Fqn, plus all parents recursively from the CacheLoader. If no CacheLoader is present, this is a no-op

  Parameters:
    `fqn` -
  Throws:
    `Exception`

### stopService

    public void stopService()

### getKeys

    public Set getKeys(String fqn)
                throws CacheException

  Throws:
    `CacheException`

### getKeys

    public Set getKeys(Fqn fqn)
                throws CacheException

  Throws:
    `CacheException`

### get

    public Object get(String fqn,
                      Object key)
               throws CacheException

  Finds a node given its name and returns the value associated with a given key in its `data` map. Returns null if the node was not found in the tree or the key was not found in the hashmap.

  Parameters:
    `fqn` - The fully qualified name of the node.
    `key` - The key.
  Throws:
    `CacheException`

### get

    public Object get(Fqn fqn,
                      Object key)
               throws CacheException

  Finds a node given its name and returns the value associated with a given key in its `data` map. Returns null if the node was not found in the tree or the key was not found in the hashmap.

  Parameters:
    `fqn` - The fully qualified name of the node.
    `key` - The key.
  Throws:
    `CacheException`

### exists

    public boolean exists(String fqn)

  Checks whether a given node exists in the tree

  Parameters:
    `fqn` - The fully qualified name of the node
  Returns:
    boolean Whether or not the node exists

### exists

    public boolean exists(Fqn fqn)

  Checks whether a given node exists in the tree. Does not acquire any locks in doing so (result may be dirty read)

  Parameters:
    `fqn` - The fully qualified name of the node
  Returns:
    boolean Whether or not the node exists

### exists

    public boolean exists(String fqn,
                          Object key)

### exists

    public boolean exists(Fqn fqn,
                          Object key)

  Checks whether a given key exists in the given node. Does not interact with CacheLoader, so the behavior is different from `get(Fqn,Object)`

  Parameters:
    `fqn` - The fully qualified name of the node
    `key` -
  Returns:
    boolean Whether or not the node exists

### put

    public void put(String fqn,
                    Map data)
             throws CacheException

  Adds a new node to the tree and sets its data. If the node doesn not yet exist, it will be created. Also, parent nodes will be created if not existent. If the node already has data, then the new data will override the old one. If the node already existed, a nodeModified() notification will be generated. Otherwise a nodeCreated() motification will be emitted.

  Parameters:
    `fqn` - The fully qualified name of the new node
    `data` - The new data. May be null if no data should be set in the node.
  Throws:
    `CacheException`

### put

    public void put(Fqn fqn,
                    Map data)
             throws CacheException

  Adds a new node to the tree and sets its data. If the node doesn not yet exist, it will be created. Also, parent nodes will be created if not existent. If the node already has data, then the new data will override the old one. If the node already existed, a nodeModified() notification will be generated. Otherwise a nodeCreated() motification will be emitted.

  Parameters:
    `fqn` - The fully qualified name of the new node
    `data` - The new data. May be null if no data should be set in the node.
  Throws:
    `CacheException`

### put

    public Object put(String fqn,
                      Object key,
                      Object value)
               throws CacheException

  Adds a key and value to a given node. If the node doesn't exist, it will be created. If the node already existed, a nodeModified() notification will be generated. Otherwise a nodeCreated() motification will be emitted.

  Parameters:
    `fqn` - The fully qualified name of the node
    `key` - The key
    `value` - The value
  Returns:
    Object The previous value (if any), if node was present
  Throws:
    `CacheException`

### put

    public Object put(Fqn fqn,
                      Object key,
                      Object value)
               throws CacheException

  Adds a key and value to a given node. If the node doesn't exist, it will be created. If the node already existed, a nodeModified() notification will be generated. Otherwise a nodeCreated() motification will be emitted.

  Parameters:
    `fqn` - The fully qualified name of the node
    `key` - The key
    `value` - The value
  Returns:
    Object The previous value (if any), if node was present
  Throws:
    `CacheException`

### remove

    public void remove(String fqn)
                throws CacheException

  Removes the node from the tree.

  Parameters:
    `fqn` - The fully qualified name of the node.
  Throws:
    `CacheException`

### remove

    public void remove(Fqn fqn)
                throws CacheException

  Removes the node from the tree.

  Parameters:
    `fqn` - The fully qualified name of the node.
  Throws:
    `CacheException`

### evict

    public void evict(Fqn fqn)
               throws CacheException

  Called by eviction policy provider. Note that eviction is done only in local mode, that is, it doesn't replicate the node removal. This is will cause the replcation nodes not synchronizing, but it is ok since user is supposed to add the node again when get is null. After that, the contents will be in sync.

  Parameters:
    `fqn` - Will remove everythign assoicated with this fqn.
  Throws:
    `CacheException`

### evict

    public void evict(Fqn fqn,
                      Object key)
               throws CacheException

  Evicts a key/value pair from a node's attributes. Note that this is local, will not be replicated.

  Parameters:
    `fqn` -
    `key` -
  Throws:
    `CacheException`

### remove

    public Object remove(String fqn,
                         Object key)
                  throws CacheException

  Removes `key` from the node's hashmap

  Parameters:
    `fqn` - The fullly qualified name of the node
    `key` - The key to be removed
  Returns:
    The previous value, or null if none was associated with the given key
  Throws:
    `CacheException`

### remove

    public Object remove(Fqn fqn,
                         Object key)
                  throws CacheException

  Removes `key` from the node's hashmap

  Parameters:
    `fqn` - The fullly qualified name of the node
    `key` - The key to be removed
  Returns:
    The previous value, or null if none was associated with the given key
  Throws:
    `CacheException`

### removeData

    public void removeData(String fqn)
                    throws CacheException

  Throws:
    `CacheException`

### removeData

    public void removeData(Fqn fqn)
                    throws CacheException

  Throws:
    `CacheException`

### releaseAllLocks

    public void releaseAllLocks(String fqn)

  Force-releases all locks in this node and the entire subtree

  Parameters:
    `fqn` -

### releaseAllLocks

    public void releaseAllLocks(Fqn fqn)

  Force-releases all locks in this node and the entire subtree

  Parameters:
    `fqn` -

### print

    public String print(String fqn)

  Prints a representation of the node defined by `fqn`. Output includes name, fqn and data.

### print

    public String print(Fqn fqn)

  Prints a representation of the node defined by `fqn`. Output includes name, fqn and data.

### getChildrenNames

    public Set getChildrenNames(String fqn)
                         throws CacheException

  Returns all children of a given node

  Parameters:
    `fqn` - The fully qualified name of the node
  Returns:
    Set A list of child names (as Strings)
  Throws:
    `CacheException`

### getChildrenNames

    public Set getChildrenNames(Fqn fqn)
                         throws CacheException

  Returns all children of a given node

  Parameters:
    `fqn` - The fully qualified name of the node
  Returns:
    Set A list of child names (as Objects). Must not be modified because this would modify the underlying node directly (will throw an exception if modification is attempted). Returns null of the parent node was not found, or if there are no children
  Throws:
    `CacheException`

### toString

    public String toString()

### printDetails

    public String printDetails()

### printLockInfo

    public String printLockInfo()

### getNumberOfLocksHeld

    public int getNumberOfLocksHeld()

  Gets the number of read or write locks held across the entire tree

  Returns:

### getNumberOfNodes

    public int getNumberOfNodes()

  Returns an approximation of the total number of nodes in the tree. Since this method doesn't acquire any locks, the number might be incorrect, or the method might even throw a ConcurrentModificationException

  Returns:

### getNumberOfAttributes

    public int getNumberOfAttributes()

  Returns an approximation of the total number of attributes in the tree. Since this method doesn't acquire any locks, the number might be incorrect, or the method might even throw a ConcurrentModificationException

  Returns:

### callRemoteMethods

    public List callRemoteMethods(Vector members,
                                  Method method,
                                  Object[] args,
                                  boolean synchronous,
                                  boolean exclude_self,
                                  long timeout)
                           throws Exception

  Throws:
    `Exception`

### callRemoteMethods

    public List callRemoteMethods(Vector members,
                                  String method_name,
                                  Class[] types,
                                  Object[] args,
                                  boolean synchronous,
                                  boolean exclude_self,
                                  long timeout)
                           throws Exception

  Throws:
    `Exception`

### _put

    public void _put(GlobalTransaction tx,
                     String fqn,
                     Map data,
                     boolean create_undo_ops)
              throws CacheException

  Does the real work. Needs to acquire locks if accessing nodes, depending on the value of `locking`. If run inside a transaction, needs to (a) add newly acquired locks to `TransactionEntry`'s lock list, (b) add nodes that were created to `TransactionEntry`'s node list and (c) create `Modification`s and add them to `TransactionEntry`'s modification list and (d) create compensating modifications to undo the changes in case of a rollback

  Parameters:
    `fqn` -
    `data` -
    `create_undo_ops` - If true, undo operations will be created (default is true). Otherwise they will not be created (used by rollback()).
  Throws:
    `CacheException`

### _put

    public void _put(GlobalTransaction tx,
                     Fqn fqn,
                     Map data,
                     boolean create_undo_ops)
              throws CacheException

  Does the real work. Needs to acquire locks if accessing nodes, depending on the value of `locking`. If run inside a transaction, needs to (a) add newly acquired locks to `TransactionEntry`'s lock list, (b) add nodes that were created to `TransactionEntry`'s node list and (c) create `Modification`s and add them to `TransactionEntry`'s modification list and (d) create compensating modifications to undo the changes in case of a rollback

  Parameters:
    `fqn` -
    `data` -
    `create_undo_ops` - If true, undo operations will be created (default is true). Otherwise they will not be created (used by rollback()).
  Throws:
    `CacheException`

### _put

    public void _put(GlobalTransaction tx,
                     Fqn fqn,
                     Map data,
                     boolean create_undo_ops,
                     boolean erase_contents)
              throws CacheException

  Does the real work. Needs to acquire locks if accessing nodes, depending on the value of `locking`. If run inside a transaction, needs to (a) add newly acquired locks to `TransactionEntry`'s lock list, (b) add nodes that were created to `TransactionEntry`'s node list and (c) create `Modification`s and add them to `TransactionEntry`'s modification list and (d) create compensating modifications to undo the changes in case of a rollback

  Parameters:
    `fqn` -
    `data` -
    `create_undo_ops` - If true, undo operations will be created (default is true).
    `erase_contents` - Clear the existing hashmap before putting the new data into it Otherwise they will not be created (used by rollback()).
  Throws:
    `CacheException`

### _put

    public Object _put(GlobalTransaction tx,
                       String fqn,
                       Object key,
                       Object value,
                       boolean create_undo_ops)
                throws CacheException

  Throws:
    `CacheException`

### _put

    public Object _put(GlobalTransaction tx,
                       Fqn fqn,
                       Object key,
                       Object value,
                       boolean create_undo_ops)
                throws CacheException

  Throws:
    `CacheException`

### _remove

    public void _remove(GlobalTransaction tx,
                        String fqn,
                        boolean create_undo_ops)
                 throws CacheException

  Throws:
    `CacheException`

### _remove

    public void _remove(GlobalTransaction tx,
                        Fqn fqn,
                        boolean create_undo_ops)
                 throws CacheException

  Throws:
    `CacheException`

### _remove

    public Object _remove(GlobalTransaction tx,
                          String fqn,
                          Object key,
                          boolean create_undo_ops)
                   throws CacheException

  Throws:
    `CacheException`

### _remove

    public Object _remove(GlobalTransaction tx,
                          Fqn fqn,
                          Object key,
                          boolean create_undo_ops)
                   throws CacheException

  Throws:
    `CacheException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002 JBoss Group, LLC. All Rights Reserved.